import type { PageServerLoad } from './$types';
import { Admin } from '$lib/server/database';
import { getSession } from '$lib/server/session';
import { Permissions } from '$lib/permissions';

export const load: PageServerLoad = async ({ cookies }) => {
	let admins: Admin[] = [];
	if (getSession(cookies, { permissions: [Permissions.AdminRead] }) != null) {
		admins = await Admin.findAll({ attributes: { exclude: ['password'] } });
	}

	const session = getSession(cookies);
	return {
		admins: admins.map((v) => {
			const vv = JSON.parse(JSON.stringify(v));
			vv.permissions = v.permissions.asArray();

			return vv;
		}) as (Admin & { [key: string]: any })[],
		id: session?.userId,
		permissions: session?.permissions.value || 0
	};
};
